# generated by datamodel-codegen:
#   filename:  https://auditlog-dev.xxllnc.nl/api
#   timestamp: 2022-06-08T13:24:04+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from pydantic import BaseModel, Field
from typing import Any, Dict, List, Optional, Union
from uuid import UUID


class AuditLogChangeTypes(Enum):
    """
    An enumeration.
    """

    insert = "insert"
    update = "update"
    delete = "delete"


class AuditLogCreate(BaseModel):
    appId: UUID = Field(..., title="Identifier of the app this event is coming from.")
    userId: Optional[str] = Field(None, title="The unique identifier of the user.")
    organizationId: UUID = Field(
        ..., title="The unique identifier of the organization of the user."
    )
    appInstanceId: Optional[UUID] = Field(
        None, title="Identifier of the app instance this event is coming from."
    )
    displayName: str = Field(
        ...,
        title=(
            "Human readable name of the logged in user that triggered the event. If the system"
            " triggered the event, the name of the system."
        ),
    )
    timestamp: datetime = Field(..., title="The date / time of the event of the audit log item.")
    changeType: AuditLogChangeTypes = Field(..., title="The change type of the audit log item.")
    summary: str = Field(..., title="The summary of the audit log item.")
    resourceUrl: Optional[str] = Field(
        None, title="Url to retrieve (GET) the resource concerning audit log item."
    )
    content: Optional[Dict[str, Any]] = Field(
        None, title="The content of the change concerning this auditlog."
    )


class AuditLogOut(BaseModel):
    appId: UUID = Field(..., title="Identifier of the app this event is coming from.")
    userId: Optional[str] = Field(None, title="The unique identifier of the user.")
    organizationId: UUID = Field(
        ..., title="The unique identifier of the organization of the user."
    )
    appInstanceId: Optional[UUID] = Field(
        None, title="Identifier of the app instance this event is coming from."
    )
    displayName: str = Field(
        ...,
        title=(
            "Human readable name of the logged in user that triggered the event. If the system"
            " triggered the event, the name of the system."
        ),
    )
    timestamp: datetime = Field(..., title="The date / time of the event of the audit log item.")
    changeType: AuditLogChangeTypes = Field(..., title="The change type of the audit log item.")
    summary: str = Field(..., title="The summary of the audit log item.")
    resourceUrl: Optional[str] = Field(
        None, title="Url to retrieve (GET) the resource concerning audit log item."
    )
    content: Optional[Dict[str, Any]] = Field(
        None, title="The content of the change concerning this auditlog."
    )
    id: UUID = Field(..., title="Unique identifier of the audit log item.")


class ValidationError(BaseModel):
    loc: List[Union[str, int]] = Field(..., title="Location")
    msg: str = Field(..., title="Message")
    type: str = Field(..., title="Error Type")


class HTTPValidationError(BaseModel):
    detail: Optional[List[ValidationError]] = Field(None, title="Detail")
